var getAuthCode = function(opt) {
    /**
     * 版本号对比方法，比如判断1.5.0和1.11.0的大小
     * oldVersion 老版本
     * newVersion 新版本
     * containEqual 是否包含相等的情况
     * result: newVersion >[=] oldVersion
     **/
    var compareVersion = function (oldVersion, newVersion, containEqual) {
        if (typeof oldVersion !== 'string' || typeof newVersion !== 'string') {
            return false;
        }
        //分割字符串为['1', '0', '1']格式
        var oldArray = oldVersion.split('.');
        var newArray = newVersion.split('.');
        var o, n;
        //从左向右对比值，值相同则跳过，不同则返回不同的值
        while (o === n && newArray.length > 0) {
            o = oldArray.shift();
            n = newArray.shift();
        }
        //返回不同值的比较结果
        if (containEqual) {
            return (n | 0) >= (o | 0);
        } else {
            return (n | 0) > (o | 0);
        }
    }

    var call =  function(opt) {
        return new Promise(function (resolve, reject) {
            my.dtBridge({
                m: opt.api,
                args: opt.args,
                onSuccess: function (result) {
                    resolve(result);
                },
                onFail: function (err) {
                    reject(err);
                }
            });
        });
    };

    var viaLwp = false;

    try {
        try {
            if (navigator && navigator.userAgent) {
                var ua = navigator.userAgent;
                var matches = ua.match(/AliApp\(\w+\/([a-zA-Z0-9.-]+)\)/);
                //android兼容处理
                if (matches === null) {
                    matches = ua.match(/DingTalk\/([a-zA-Z0-9.-]+)/);
                }
                var version = matches && matches[1];
                var android = (/Android/i).test(ua);
                var ver = opt.ver || '4.3.6';
                if (android && !compareVersion(ver, version, false)) {
                    viaLwp = true;
                }
            }
        }
        catch (e) {
            console.error(e);
        }

        if (opt.forceLwp) {
            viaLwp = true;
        }

        if (viaLwp) {
            return call({
                api: 'internal.request.lwp',
                args: {
                    uri: '/r/Adaptor/OAPII/authorize4MicroappWithMiniApp',
                    body: JSON.stringify([opt.corpId, opt.miniAppId])
                }
            }).then(function(res) {
                if (res && res.responseText 
                    && typeof res.responseText === 'string') {
                    return {
                        code: res && res.responseText
                    };
                }
                else {
                    throw res;
                }
            }).catch(function(err) {
                throw err;
            });
        }
        else {
            return call({
                api: 'runtime.permission.requestAuthCode',
                args: opt
            });
        }
    }
    catch (e) {
        console.log(e);
        return new Promise(function (resolve, reject) {
            reject(e);
        });
    }
};

export default getAuthCode;